//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2010-2010 - DIGITEO - 
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//



function []=Param_Freq_pre_simulate(scs_m, needcompile)
disp("Calling Param_Freq_pre_simulate..."); 
    scs=[]
// On recopie le scs_m
    scs=scs_m;
  // Retrieve all objects
    objs = scs_m.objs;
    
    nombre_blocs=0;    //Nombre de blocs dans le diagramme
    nombre_liens=0;    //Nombre de lien dans le diagramme
    nombre_rep_freq=0; //Nombre de blocs REP_FREQ dans le diagramme
    nombre_grandeur_phy=0;  //Nombre de blocs IN_Bode dans le diagramme
    num_grandeur_phy=[];    //Numéro des blocs grandeur physique dans le diagramme
    input_signals=[];   //vecteur des grandeurs d'entrée
    output_signals=[];   // vecteur des grandeurs de sortie
    type_diag=[];        // vecteur des types de diagrammes à tracer
//    nombre_out_bode=0;  //Nombre de blocs OUT_Bode dans le diagramme
//    num_out_bode=[];    //Numéro des blocs OUT_bode dans le diagramme
    wmin=0;
    wmax=0;
    num_w=0;            // Nombre de fréquences à tracer
    omega=[]             //vecteur des pulsations à tracer dans la réponse fréquentielle
    
    //Récupère le nombre de blocs dans le modèle
    for i=1:size(objs)
        if typeof(objs(i))=='Block' then
            nombre_blocs=nombre_blocs+1;
        end
    end
    nombre_liens=size(objs)-nombre_blocs;  //calcul du nombre de liens
  
    // Récupère les blocs REP_freq et les paramètres associés
    for i=1:nombre_blocs
        if objs(i).gui=="REP_FREQ" then nombre_rep_freq=nombre_rep_freq+1;
            num_rep_freq(nombre_rep_freq)=i;
            input_signals(nombre_rep_freq)=objs(i).model.opar(1);
            output_signals(nombre_rep_freq)=objs(i).model.opar(2);
            type_diag(nombre_rep_freq)=objs(i).model.ipar;
            w_min=objs(i).model.rpar(1);
            w_max=objs(i).model.rpar(2);
            if exists("objs(i).model.rpar(3)") then
                if ~isempty(objs(i).model.rpar(3)) then
                num_w=objs(i).model.rpar(3);         
            end
            end
        end
    end
    
    // s'il y a déja des blocs IN_f et OUT_f, on demande à l'utilisateur de les retirer
       probleme_in_f=%f
       for i=1:nombre_blocs
          if objs(i).gui=="IN_f" | objs(i).gui=="OUT_f" then probleme_in_f=%t;
          end
       end
       if probleme_in_f then disp('Le tracé des réponses fréquentielles est incompatible avec la présence de blocs IN_f et OUT_f')
       end
       
    
//-------------------------- Traitement à proprement parler
// Pour chacun des bloc REP_FREQ trouvés dans le diagramme

 for i=1:nombre_rep_freq   //i est le bloc rep_freq que l'on traite
     scs=scs_m; // On repart sur un diagramme propre
     num_in=[] // le numéro du bloc d'entrée dans le diagramme original
     num_out=[] // Le numéro du bloc de sortie dans le diagramme original
     
 nombre_blocs=0
 nombre_liens=0;    
      for ii=1:size(objs)
        if typeof(objs(ii))=='Block' then
            nombre_blocs=nombre_blocs+1;
        end
    end
    nombre_liens=size(objs)-nombre_blocs;  //calcul du nombre de liens
  
     
     // On récupère le bloc grandeur physique d'entrée
     for j = 1:size(scs.objs) 
         curObj= scs.objs(j);
         if (typeof(curObj) == "Block" & curObj.gui == "GRANDEUR_PHYSIQUE")
             if curObj.graphics.exprs==input_signals(i) then
                 num_in=j;
             end
         end
     end

       // Décale tous les liens d'un cran
            for k=1:nombre_liens
            scs.objs(nombre_blocs+nombre_liens+2-k)=scs.objs(nombre_blocs+nombre_liens+1-k);   
            end
           
            //On décale tout les pin et pout des blocs pour rester en concordances avec les liens
            for l=1:nombre_blocs
                if ~isempty(scs.objs(l).graphics.pin) then scs.objs(l).graphics.pin=scs.objs(l).graphics.pin+1;
                end
                if ~isempty(scs.objs(l).graphics.pout) then scs.objs(l).graphics.pout=scs.objs(l).graphics.pout+1;
                end
                if ~isempty(scs.objs(l).graphics.pein) then scs.objs(l).graphics.pein=scs.objs(l).graphics.pein+1;
                end
                if ~isempty(scs.objs(l).graphics.peout) then scs.objs(l).graphics.peout=scs.objs(l).graphics.peout+1;
                end
            end
                   
      

            
            // Crée un bloc grandeur physique d'entrée en tant qu'objet nombre blocs+1 avec le numéro d'entrée correspondant
            
            nombre_blocs=nombre_blocs+1;   // Le nombre de bloc est incrémenté
            scs.objs(nombre_blocs)=IN_f('define'); // Crée un nouveau bloc IN_f
            scs.objs(nombre_blocs).graphics.exprs=scs_m.objs(num_in).graphics.exprs;  // On récupère le numéro de l'entrée
            //Remplace le blocs IN_Bode par un sommateur
            scs.objs(num_in)=BIGSOM_f('define');
            
           
            // Crée un nouveau lien
            nombre_liens=nombre_liens+1
            scs.objs(size(scs.objs)+1)=scicos_link();
            
            
            // On relie les nouveaux blocs aux liens existants et au nouveau lien
          
                // pour le sommateur
                scs.objs(num_in).graphics.orig=scs_m.objs(num_in).graphics.orig;
                scs.objs(num_in).graphics.pin= [scs_m.objs(num_in).graphics.pin(1);nombre_liens+nombre_blocs];
                scs.objs(num_in).graphics.pout= scs_m.objs(num_in).graphics.pout;
                scs.objs(num_in).graphics.sz= [40,40];
                
                //Pour le bloc IN_f
                scs.objs(nombre_blocs).graphics.orig=[scs_m.objs(num_in).graphics.orig(1)+30,scs_m.objs(num_in).graphics.orig(2)-30];
                scs.objs(nombre_blocs).graphics.sz=[40,40];
                scs.objs(nombre_blocs).graphics.pout=nombre_liens+nombre_blocs;
               
                //Pour le lien qui a été créé
                scs.objs(size(scs.objs)).xx=[scs.objs(nombre_blocs).graphics.orig(1) scs_m.objs(num_in).graphics.orig(1)];
                scs.objs(size(scs.objs)).yy=[scs.objs(nombre_blocs).graphics.orig(2) scs_m.objs(num_in).graphics.orig(2)] ;
                scs.objs(size(scs.objs)).id='drawlink';
                scs.objs(size(scs.objs)).thick=[0 0];
                scs.objs(size(scs.objs)).ct=[1 1];
                scs.objs(size(scs.objs)).from=[nombre_blocs 1 0];
                scs.objs(size(scs.objs)).to=[num_in 2 1];
          


//-------------------------------------
// Traitement de la sortie
objs=scs.objs;
   //Récupère le bloc grandeur physique de sortie
         for j = 1:size(scs.objs) 
         curObj= scs.objs(j);
         if (typeof(curObj) == "Block" & curObj.gui == "GRANDEUR_PHYSIQUE")
             if curObj.graphics.exprs==output_signals(i) then
                 num_out=j;
             end
         end
     end

               
       // Décale tout les liens d'un cran
            for k=1:nombre_liens
            scs.objs(nombre_blocs+nombre_liens+2-k)=scs.objs(nombre_blocs+nombre_liens+1-k);   
            end
            
            //On décale tout les pin et pout des blocs pour rester en concordances avec les liens
            for l=1:nombre_blocs
                if ~isempty(scs.objs(l).graphics.pin) then scs.objs(l).graphics.pin=scs.objs(l).graphics.pin+1;
                end
                if ~isempty(scs.objs(l).graphics.pout) then scs.objs(l).graphics.pout=scs.objs(l).graphics.pout+1;
                end
                 if ~isempty(scs.objs(l).graphics.pein) then scs.objs(l).graphics.pein=scs.objs(l).graphics.pein+1;
                end
                if ~isempty(scs.objs(l).graphics.peout) then scs.objs(l).graphics.peout=scs.objs(l).graphics.peout+1;
                end
            end
            
            // Crée un bloc OUT_f en tant qu'objet nombre blocs+1 avec le numéro de sortie correspondant
            
            nombre_blocs=nombre_blocs+1;   // Le nombre de bloc est incrémenté
            scs.objs(nombre_blocs)=OUT_f('define'); // Crée un nouveau bloc out_f
            scs.objs(nombre_blocs).graphics.exprs=scs_m.objs(num_out).graphics.exprs ; // On récupère le numéro de l'entrée
            
            //Remplace le blocs grandeur physique de sortie par un embranchement (split_f)
            scs.objs(num_out)=SPLIT_f('define');
            
           
            // Crée un nouveau lien
            nombre_liens=nombre_liens+1
            scs.objs(size(scs.objs)+1)=scicos_link();
            
            
            // On relie les nouveaux blocs aux liens existants et au nouveau lien
        
                // pour le split_f
                scs.objs(num_out).graphics.orig=scs_m.objs(num_out).graphics.orig;
                scs.objs(num_out).graphics.pin= [scs_m.objs(num_out).graphics.pin(1)];
                scs.objs(num_out).graphics.pout= [scs_m.objs(num_out).graphics.pout;nombre_liens+nombre_blocs];
                
                
                //Pour le bloc OUT_f
                scs.objs(nombre_blocs).graphics.orig=[scs_m.objs(num_out).graphics.orig(1)+10,scs_m.objs(num_out).graphics.orig(2)-30];
                scs.objs(nombre_blocs).graphics.sz=[40,40];
                scs.objs(nombre_blocs).graphics.pin=nombre_liens+nombre_blocs;
               
                //Pour le lien qui a été créé
                scs.objs(size(scs.objs)).xx=[scs.objs(nombre_blocs).graphics.orig(1) scs_m.objs(num_out).graphics.orig(1)];
                scs.objs(size(scs.objs)).yy=[scs.objs(nombre_blocs).graphics.orig(2) scs_m.objs(num_out).graphics.orig(2)] ;
                scs.objs(size(scs.objs)).id='drawlink';
                scs.objs(size(scs.objs)).thick=[0 0];
                scs.objs(size(scs.objs)).ct=[1 1];
                scs.objs(size(scs.objs)).from=[num_out 2 0];
                scs.objs(size(scs.objs)).to=[nombre_blocs 1 1];
               
 
 // On récupere le numéro du bloc PARAM_VAR puis les caractéristiques correspondantes
for ii = 1:size(scs.objs)
    curObj= scs.objs(ii);
        if (typeof(curObj) == "Block" & curObj.gui == "PARAM_VAR")
            if length(curObj.model.opar)>0 then 
                param1=curObj.model.opar(1)
                param1val=curObj.model.opar(2)
            end
            if length(curObj.model.opar)>2 then 
                param2=curObj.model.opar(3)
                param2val=curObj.model.opar(4)
            end
            if length(curObj.model.opar)>4 then 
                param3=curObj.model.opar(5)
                param3val=curObj.model.opar(6)
            end
        end
end
 
 
 num_param=0;
if ~isempty(param1) then num_param=num_param+1;
end
if ~isempty(param2) then num_param=num_param+1;
end
if ~isempty(param3) then num_param=num_param+1;
end

if  num_param<>1 then message('Les études paramètriques en fréquentielle nécessite un et un seul paramètres variable');
    error('wrong parameters number')
end
 
 scs_ok=scs;
 // Pour chacune des valeur des parametre il faut linéariser et tracer le diagramme de Bode
 
Nsimu=0  //Numero de la simu
x=0
//exec('C:\demo xcos\sources cpge\macros\do_eval_ps.sci', -1)  // Redefinition de la fonction do_eval pour ne pas avoir besoin de needcompile
// Ca facilite le débuggage


for kk=1:length(param1val)
    
    context=scs.props.context;
    context($+1)=string(param1)+"="+string(param1val(kk))
    [%scicos_context, ierr] = script2var(context,struct())
    %cpr=list();
 //   if exists('needcompile') then
    [scs2, %cpr, needcompile, ok] = do_eval(scs, %cpr,%scicos_context);
//else
//    [scs2, %cpr, needcompile, ok] = do_eval_ps(scs, %cpr,%scicos_context);
//    end
    
    commande='sys'+string(kk)+'=lincos(scs2)'
    try
    execstr(commande)
catch
    message('Scilab n a pas réussi à déterminer la fonction de transfert du système. Vérifiez que tous les blocs sont linéaires et causaux')
    end
end

legende=[]
  for zz=1:length(param1val)
  legende(1,zz)=string(param1)+"="+string(param1val(zz))
end

  // On construit le vecteur des omega
  if num_w>0 then
      omega=logspace(log10(w_min),log10(w_max),num_w);
  end

// On choisit le diagramme à tracer
  h=figure();

  select type_diag(i)
 
  case 1

  commande_bode='bode(['
 for zz=1:length(param1val)
     if zz<> length(param1val) then
     commande_bode=commande_bode+'sys'+string(zz)+';'
 else
     commande_bode=commande_bode+'sys'+string(zz)
     end
      end
commande_bode=commande_bode+'],w_min,w_max,legende)'
execstr(commande_bode)
set(h,"background",8) 

   
    
  case 2
     
       commande_black='black(['
 for zz=1:length(param1val)
     if zz<> length(param1val) then
     commande_black=commande_black+'sys'+string(zz)+';'
 else
     commande_black=commande_black+'sys'+string(zz)
     end
  
    end
//commande_black=commande_black+'],w_min,w_max,legende)'
commande_black=commande_black+'],w_min,w_max)'
execstr(commande_black)
  nicholschart(colors=color('light gray')*[1 1])
case 3
   
        commande_nyquist='nyquist(['
 for zz=1:length(param1val)
     if zz<> length(param1val) then
     commande_nyquist=commande_nyquist+'sys'+string(zz)+';'
 else
     commande_nyquist=commande_nyquist+'sys'+string(zz)
     end
  
    end
//commande_nyquist=commande_nyquist+'],w_min,w_max,legende)'
commande_nyquist=commande_nyquist+'],w_min,w_max)'
execstr(commande_nyquist)    
  end
set(h,"background",8) 
     end  
            
endfunction
